From 5b80a602143b5263fa48c9a338afe909a62dc53c Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Mar 21 2017 09:44:19 +0000
Subject: [PATCH 809/1001] Add tests for the halp widget


---

diff --git a/hubs/tests/test_widgets/test_halp.py b/hubs/tests/test_widgets/test_halp.py
new file mode 100644
index 0000000..8950429
--- /dev/null
+++ b/hubs/tests/test_widgets/test_halp.py
@@ -0,0 +1,107 @@
+from __future__ import unicode_literals, absolute_import
+
+import json
+
+from hubs.models import Hub
+from hubs.tests import captured_templates
+from hubs.tests.test_widgets import WidgetTest
+from hubs.widgets import registry
+
+
+class HalpViewsTestCase(WidgetTest):
+    plugin = 'halp'  # The name in hubs.widgets.registry
+
+    def setUp(self):
+        super(HalpViewsTestCase, self).setUp()
+        self.widget = self.widget_instance('ralph', self.plugin)
+        config = self.widget.config
+        config["hubs"] = ["fedora-devel"]
+
+    def test_root(self):
+        with captured_templates(self.widget.module) as templates:
+            response = self.app.get('/ralph/w/halp/%i/' % self.widget.idx)
+        self.assertEqual(response.status_code, 200)
+        self.assertEqual(len(templates), 1)
+        _template, context = templates[0]
+        self.assertEqual(context["hubs"], [])
+
+    def test_json(self):
+        response = self.app.get('/ralph/%i/json' % self.widget.idx)
+        self.assertEqual(response.status_code, 200)
+        data = json.loads(response.get_data(as_text=True))
+        self.assertEquals(data['plugin'], 'halp')
+        self.assertIn('hubs', data['data'].keys())
+
+    def test_config_add(self):
+        with captured_templates(self.widget.module) as templates:
+            response = self.app.get('/ralph/w/halp/add?position=right')
+        self.assertEqual(response.status_code, 200)
+        self.assertEqual(len(templates), 1)
+        _template, context = templates[0]
+        self.assertEqual(context["mode"], "add")
+        self.assertEqual(context["initial"], {
+            "hubs": ["ralph"], "per_page": 4,
+            })
+        self.assertEqual(context["url"], "/ralph/add/halp?position=right")
+
+    def test_config_edit(self):
+        with captured_templates(self.widget.module) as templates:
+            response = self.app.get('/ralph/w/halp/%i/config'
+                                    % self.widget.idx)
+        self.assertEqual(response.status_code, 200)
+        self.assertEqual(len(templates), 1)
+        _template, context = templates[0]
+        self.assertEqual(context["mode"], "edit")
+        self.assertEqual(context["initial"], {})
+        self.assertEqual(context["url"], "/ralph/%i/edit" % self.widget.idx)
+
+    def test_config_hubs_suggest(self):
+        response = self.app.get('/w/halp/hubs')
+        self.assertEqual(response.status_code, 200)
+        data = json.loads(response.get_data(as_text=True))
+        self.assertDictEqual(data, {
+            'results': ['decause', 'devyani7', 'dhrish', 'i18n', 'infra']
+        })
+
+
+class HalpFunctionsTestCase(WidgetTest):
+    plugin = 'halp'  # The name in hubs.widgets.registry
+
+    def setUp(self):
+        super(HalpFunctionsTestCase, self).setUp()
+        module = registry[self.plugin]
+        func_class = module.get_cached_functions()['GetRequests']
+        self.widget = self.widget_instance('ralph', self.plugin)
+        self.func = func_class(self.widget)
+        # The tested widget watches the infra hub.
+        config = self.widget.config
+        config["hubs"] = ["infra"]
+        self.widget.config = config
+        # The infra hub works in the fedora-infra channel.
+        infra_hub = Hub.query.filter_by(name="infra").one()
+        infra_hub.config.chat_channel = "#fedora-infra"
+        self.session.commit()
+
+    def test_should_invalidate_wrong_topic(self):
+        msg = {'topic': 'hubs.WRONG.TOPIC'}
+        result = self.func.should_invalidate(msg)
+        self.assertFalse(result)
+
+    def test_should_invalidate_wrong_hub(self):
+        # The decause hub works in the fedora-commops channel.
+        decause_hub = Hub.query.filter_by(name="decause").one()
+        decause_hub.config.chat_channel = "#fedora-commops"
+        self.session.commit()
+        msg = {'topic': 'org.fedoraproject.prod.meetbot.meeting.item.help',
+               'msg': {'channel': '#fedora-commops'},
+               }
+        # The decause hub cache would be invalidated, but not ours.
+        result = self.func.should_invalidate(msg)
+        self.assertFalse(result)
+
+    def test_should_invalidate_good_match(self):
+        msg = {'topic': 'org.fedoraproject.prod.meetbot.meeting.item.help',
+               'msg': {'channel': '#fedora-infra'},
+               }
+        result = self.func.should_invalidate(msg)
+        self.assertTrue(result)

